import com.smartvault.proto.NodeProto;

import java.awt.*;
import java.net.URI;
import java.nio.file.Paths;
import java.util.Scanner;

public class Program
{

    private static Scanner keyboard = new Scanner(System.in);

    public static void main(String[] args)
    {
        try
        {
            SmartVault smartVault = new SmartVault();
            authenticate(smartVault);
            System.out.println("Authentication complete.");
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        System.out.println("\nPress 'Enter' key to exit");
        keyboard.nextLine();
    }

    private static void authenticate(SmartVault smartVault) throws Exception
    {
        // Autonomous authentication
        System.out.print("Enter your email address: ");
        String email = keyboard.nextLine();

        System.out.print("Have you authorized this application? [y/n]: ");
        String response = keyboard.nextLine();

        if (!response.toLowerCase().startsWith("y"))
        {
            String url = smartVault.requestAuthorization(email);
            Desktop.getDesktop().browse(URI.create(url));
            System.out.println("\nPress 'Enter' once you have allowed this application.");
            keyboard.nextLine();
        }

        smartVault.authenticate(email);
    }
}