/*****************************************************************************
Copyright (c) 2011 SmartVault, Inc.

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ******************************************************************************/
package com.smartvault.rest;

import java.util.HashMap;
import java.util.Map;

public class NodeOptions {
	public int children;
	public boolean acl;
	public boolean includeExtendedProperties;
	public String searchCriteria;
	public String sort;
	public String sortDirection;
	public int page;
	public int perPage = 50;
	
	private void insertIfNotNull(Map<String, String> map, String key, String value) {
		
		if (null != value) {
			map.put(key, value);
		}
	
	}
	
	public Map<String, String> getOptions() {
		Map<String, String> m = new HashMap<String, String>();
		insertIfNotNull(m, Constants.CHILDREN_PARAMETER, Integer.toString(children));
		insertIfNotNull(m, Constants.ACL_PARAMETER, acl ? "1" : "0");
		insertIfNotNull(m, Constants.INCLUDE_EXTENDED_PROPERTIES, includeExtendedProperties ? "1" : "0");
		insertIfNotNull(m, Constants.SEARCH_CRITERIA, searchCriteria);
		insertIfNotNull(m, Constants.SORT_FIELD, sort);
		insertIfNotNull(m, Constants.SORT_DIRECTION, sortDirection);
		insertIfNotNull(m, Constants.PAGE, Integer.toString(page));
		insertIfNotNull(m, Constants.PER_PAGE, Integer.toString(perPage));
		return m;
	}
}
